(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core'], factory) :
	(factory((global.ngx = global.ngx || {}, global.ngx.clipboard = global.ngx.clipboard || {}),global.ng.core));
}(this, (function (exports,_angular_core) { 'use strict';

var ClipboardDirective = (function () {
    /**
     * @param {?} elmRef
     * @param {?} renderer
     */
    function ClipboardDirective(elmRef, renderer) {
        this.elmRef = elmRef;
        this.renderer = renderer;
        this.cbOnSuccess = new _angular_core.EventEmitter();
        this.cbOnError = new _angular_core.EventEmitter();
    }
    /**
     * @return {?}
     */
    ClipboardDirective.prototype.ngOnInit = function () {
        // let option: Clipboard.Options;
        // option = !!this.targetElm ? { target: () => <any>this.targetElm } : { text: () => this.cbContent };
        // this.clipboard = new Clipboard(this.elmRef.nativeElement, option);
        // this.clipboard.on('success', (e) => this.cbOnSuccess.emit(e));
        // this.clipboard.on('error', (e) => this.cbOnError.emit(e));
    };
    /**
     * @return {?}
     */
    ClipboardDirective.prototype.ngOnDestroy = function () {
        // if (this.clipboard) {
        //     this.clipboard.destroy();
        // }
    };
    /**
     * @param {?} button
     * @return {?}
     */
    ClipboardDirective.prototype.onClick = function (button) {
        if (this.targetElm) {
            this.selectedText = this.targetElm.nativeElement.value;
            this.selectTarget(this.targetElm.nativeElement);
            this.handleResult(this.copyText());
            this.clearSelection(this.targetElm.nativeElement, window);
        }
    };
    /**
     * @param {?} nativeElement
     * @return {?}
     */
    ClipboardDirective.prototype.selectTarget = function (nativeElement) {
        // TODO: handle contenteditable or selection
        if (nativeElement.nodeName === 'INPUT' || nativeElement.nodeName === 'TEXTAREA') {
            // TODO: might need to set readonly first
            this.renderer.invokeElementMethod(nativeElement, 'select');
            this.renderer.invokeElementMethod(nativeElement, 'setSelectionRange', [0, nativeElement.value.length]);
        }
    };
    /**
     * @return {?}
     */
    ClipboardDirective.prototype.copyText = function () {
        try {
            // TODO: shouldn't use document directly
            return document.execCommand('copy');
        }
        catch (err) {
            throw new Error('fail to perform copy');
        }
    };
    /**
     * Fires an event based on the copy operation result.
    \@param {Boolean} succeeded
     * @param {?} succeeded
     * @return {?}
     */
    ClipboardDirective.prototype.handleResult = function (succeeded) {
        if (succeeded) {
            this.cbOnSuccess.emit({ isSuccess: true, content: this.selectedText });
        }
        else {
            this.cbOnError.emit({ isSuccess: false });
        }
    };
    /**
     * Removes current selection and focus from `target` element.
     * @param {?} nativeElement
     * @param {?} window
     * @return {?}
     */
    ClipboardDirective.prototype.clearSelection = function (nativeElement, window) {
        nativeElement && nativeElement.blur();
        // TODO: should inject window
        window.getSelection().removeAllRanges();
    };
    return ClipboardDirective;
}());
ClipboardDirective.decorators = [
    { type: _angular_core.Directive, args: [{
                selector: '[ngxClipboard]'
            },] },
];
/**
 * @nocollapse
 */
ClipboardDirective.ctorParameters = function () { return [
    { type: _angular_core.ElementRef, },
    { type: _angular_core.Renderer, },
]; };
ClipboardDirective.propDecorators = {
    'targetElm': [{ type: _angular_core.Input, args: ['ngxClipboard',] },],
    'cbContent': [{ type: _angular_core.Input },],
    'cbOnSuccess': [{ type: _angular_core.Output },],
    'cbOnError': [{ type: _angular_core.Output },],
    'onClick': [{ type: _angular_core.HostListener, args: ['click', ['$event.target'],] },],
};

var ClipboardModule = (function () {
    function ClipboardModule() {
    }
    return ClipboardModule;
}());
// static forRoot(): ModuleWithProviders { return { ngModule: ClipboardModule, providers: [] }; }
ClipboardModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                declarations: [ClipboardDirective],
                exports: [ClipboardDirective]
            },] },
];
/**
 * @nocollapse
 */
ClipboardModule.ctorParameters = function () { return []; };

exports.ClipboardModule = ClipboardModule;
exports.ClipboardDirective = ClipboardDirective;

Object.defineProperty(exports, '__esModule', { value: true });

})));
