import { ElementRef, EventEmitter, OnInit, OnDestroy, Renderer } from '@angular/core';
export declare class ClipboardDirective implements OnInit, OnDestroy {
    private elmRef;
    private renderer;
    targetElm: ElementRef;
    cbContent: string;
    cbOnSuccess: EventEmitter<any>;
    cbOnError: EventEmitter<any>;
    private selectedText;
    constructor(elmRef: ElementRef, renderer: Renderer);
    ngOnInit(): void;
    ngOnDestroy(): void;
    private onClick(button);
    private selectTarget(nativeElement);
    private copyText();
    /**
     * Fires an event based on the copy operation result.
     * @param {Boolean} succeeded
     */
    private handleResult(succeeded);
    /**
       * Removes current selection and focus from `target` element.
       */
    private clearSelection(nativeElement, window);
}
